/*
   File...: BDEAliasEX.CC
   Author.: Roland Wingerter
   Date...: January 6, 2004
   Notes..: An enhanced version of BDEAlias.cc in the DUFLP,
            this allows creation of an MSACCESS database
            alias, and also handles closing and restarting the
            BDE ...
   Dependencies: :dUFLP:BDEAlias.cc
*/

CLASS bdeAliasEx of bdeAlias from :dUFLP:bdealias.cc

   Function CreateAlias(cAliasName, cPath, cTableFormat)
      // cAliasName = the Alias name that the database is to
      //              be referred to
      // cPath      = the full path to the database
      // cTableFormat = the table format (i.e., INTRBASE, DBASE, MSACCESS etc.)
      // 
      // The original function from bdeAlias.cc modified 
      // by R. Wingerter, 24 Sept. 2004:
      // - replaced literal value "PATH" with variable cProperty 
      //   because for MSAccess we need to assign the database path 
      //  to the property "DATABASE NAME"
      local cProperty 

      cProperty = "PATH"

      if pCount() < 3
        cTableFormat = "DBASE"
      elseif cTableFormat = "MSACCESS"
        cProperty = "DATABASE NAME"   
      endif
      //Creates an Alias

      if type("DbiAddAlias") # "FP"
        extern cint DbiAddAlias(;
               cHandle,;
               CPTR,;
               CPTR,;
               CPTR,;
               clogical) idapi32
      endif
     
      return DbiAddAlias(null,;
                     this.toUnicode(cAliasName),;
                     this.toUnicode(cTableFormat),;
                     this.toUnicode(cProperty + ":" + cPath),;
                     TRUE)==0

   Function restartBDE
      // Thanks to Vic McClung for this routine in SetTableLevel.prg
      close databases
      if type('DbiExit') # "FP"
         EXTERN cword DbiExit(cvoid) idapi32.dll
      endif
      DbiExit()
      if type('DbiInitFn') # "FP"
         EXTERN cword DbiInitFn(cword, cptr) idapi32.dll
      endif
      DbiInitFn(300, null)
   return

ENDCLASS
