/*
   filename ENTRYDROP5.CC
   My attempt at a combobox for ADO and BDE 
   Peter Balfour Mar 2017 V4.1
 
    updates:
	 March 2021 V5.0
	 Example forms updated to show setup in component OnOpen not Form OnOpen
	 Disabled timer when in form design mode to prevent dBase crash on save and allow re-sizing in designer
	 Updated Init function - put grid creation into objects section and stopped inspector showing "Parent" as name of component.
	 Grid width put in ed_drop_fold
    changed the way parameters are handled V4.0
    made delete key work with mouse V4.0
    changed drop and fold to drop_fold so can run from different places 22/12/16 V4.0
    changed on_key so tab and enter cause tab to form 22/12/2016 V4.0
     Jan 06 2016
    complete update
    Changed OnKey for timer after kind suggestion from
    Mervyn Bick
    put auto init into .cc March 2017 V4.1
    added this.dropped to prevent ed_drop_fold running each time the timer fired March 2017 V4.1
    added overwrite property to blank out when got focus March 2017 V4.1
    Jan 2018
    Changed name and filename to ENTRYDROP5 
    On getting focus stopped dropdown if entry exists 
    added new example forms 
 
    ********** There is a ADO example form below code ********
    
    ********** There is a BDE example form below ADO example ********
    
    Jan 06 2016
    complete update
    Changed OnKey for timer after kind suggestion from
    Mervyn Bick
    
    For ADO parameters["x"].value = whatever
    for BDE  params["x"] = whatever
    
     
    Use:
    To filter the rowset to find fields starting with the value when containedin is false
    To filter the rowset to find fields containing the value when containedin is true
    Choose a value
    
    To use:
    
   set procedure to EntryDrop5.cc 
	
	See the example forms below for the onOpen setups
	
      If you want a function to fire when search succeeds
      then in the form:
      
      function show_rec //(see in the form_onOpen above)
      do something
      return
      
      
      infogrid.lockedColumns defaults to infoq.rowset.fields.size
      

*/
		
class ENTRYDROP5(oObj) of container(oObj) custom
	
   onClose = CLASS::onClose
   this.height = 125/100

	//create the objects

	this.infoQ      = new object()
	this.ED_onSelect  = ""
	this.ED_onFound  = ""
	this.ED_onFailed  = ""
	this.ED_OnGotFocus = ""
	this.ContainedIn = false
	this.overwrite = false
	this.qparam = ''
	this.value = ""
	this.dropdown = 15
	this.focustime = time(1)
	this.ado = true
	this.EDtest = ''
	this.initialised = false
	this.selected = ""
	
	
	this.EF = new entryfield(this)
	with (this.EF)
	   onGotFocus = class::init
		height = 1
		width = this.width
		function = "!"
      value = ""
		top = 0
		left = 0
   endwith

	this.selb = new text(this)
	with (this.selb)
      top = 0
      text = 'V'
      border = true
      width = 0
      left = 0
      alignVertical = 1	// Middle
      alignHorizontal = 1	// Center
      borderStyle = 4	// Single
      visible = false
	endwith
	
	this.rset = new text(this)
	with (this.rset)
      top = 0
      text = 'R'
      border = true
      left = 0
      width = 0
      alignVertical = 1	// Middle
      alignHorizontal = 1	// Center
      borderStyle = 4	// Single
      visible = false
	endwith
	
	this.infoGRID = new GRID(this)
	
	function onClose
      this.ptimer.enabled = false
      this.ptimer = null
      on key label Uparrow 
      on key label Dnarrow
      _App.navrow = ''
   return 
	
   function init
	
		m = this.parent
		if m.initialised = true;return;endif
      m.initialised := true
      try
      with (m.infoGRID)
         datalink   := m.infoq.rowset
         allowColumnMoving = false
         allowEditing = false
         allowAddRows = false
         hScrollBar = 0	// Off
         vScrollBar = 1	// on
         height = m.parent.height - m.EF.height
         left = 0
         top = m.EF.height
         width = m.parent.width * 95/100
         lockedColumns = m.infoq.rowset.fields.size
      endwith
      catch(exception e)
		msgbox("query not set")
		return
		endtry
      m.infogrid.width := m.width //* 90/100
      m.infogrid.height := m.height - m.ef.height
      m.infogrid.onleftmousedown = class::infogrid_onleftmousedown
      m.ef.width = m.width * 84/100
      m.selb.width = m.width * 7/100
      m.selb.height = m.ef.height
      m.selb.left = m.ef.width
      m.selb.onleftmousedown = class::selb_onleftmousedown
      m.selb.visible = true
      m.rset.width = m.width * 7/100
      m.rset.height = m.ef.height
      m.rset.left = m.ef.width + m.selb.width
      m.rset.onleftmousedown = class::reset
      m.rset.visible = true
      m.height = m.ef.height * 125/100
      m.dropped = false
      m.EF.onGotFocus = class::EF_ONGOTFOCUS
      m.EF.onleftmousedown = class::EF_ONGOTFOCUS
      m.EF.onLostFocus = class::EF_ONLOSTFOCUS
      m.EF.key = class::EF_key
		 m.ptimer = new Timer( ) 
	    m.ptimer.parent = m 
	    m.ptimer.onTimer = m.ED_onchange  
	    m.ptimer.interval = .1  
		if not m.parent.indesign
		m.ptimer.enabled = true
		endif
      m.selb.text = 'V'
      m.dropped = false
      m.ed_drop_fold(m)
      _App.navrow = m.infoQ.rowset
      on key label Uparrow rowup() 
      on key label Dnarrow rowdown()
      m.ef.setfocus()
      m = null
   return
	
   function set_query(efv)
      if this.ContainedIn = true;CiChar = "%";else;CiChar = "";endif
         NC = CiChar + trim(efv) + '%'
      if this.ado
         this.infoQ.parameters[this.qparam].value = NC
      else
         this.infoQ.params[this.qparam] = NC
      endif
      this.infoQ.requery()
	return this.infoQ.rowset.count()
	
 	function EF_onGotFocus 

      if ELAPSED(time(1), this.parent.focustime ,1)  < .5 ; return ; endif
      this.parent.focustime = time(1)
      if this.parent.overwrite = true;this.value = '';endif
      if this.value == ""
         this.parent.ptimer.enabled = true
         this.parent.selb.text = 'V'
         this.parent.dropped = false
         this.parent.ed_drop_fold(this.parent)
         this.parent.set_query(this.value)
      else
         this.parent.selected = this.value
      endif
      _App.navrow = this.parent.infoQ.rowset
      on key label Uparrow rowup() 
      on key label Dnarrow rowdown()
      

      if not this.parent.ED_OnGotFocus == ""
         d = 'this.parent.parent.' + this.parent.ED_OnGotFocus
         &d()
      endif
      
	return

   function EF_onLostFocus
      this.parent.ptimer.enabled = false
      on key label Uparrow 
      on key label Dnarrow
      _App.navrow = ''
   return
		
	function EF_KEY(nChar, nPosition,bShift,bControl)
      if nChar=13  
         this.parent.x_selected(this.parent)
         return
      endif
      if nChar = 9
         this.parent.x_selected(this.parent)
         this.parent.parent.nextObj.setfocus()
         return 
      endif
      if this.parent.ptimer.enabled = false
         this.parent.selected = false
         this.parent.ptimer.enabled = true
         this.parent.selb.text = 'V'
         this.parent.dropped = false
         this.parent.ed_drop_fold(this.parent)
         this.parent.set_query(this.value)
      endif	
	return
		
	function reset
      this.parent.set_query('')
      this.parent.selb.text = 'V'
      this.parent.dropped = false
      this.parent.ef.value = ""
      this.parent.ed_drop_fold(this.parent)
	return
	

	function ED_onchange
      m = this.parent // entrydrop3
		if m.dropped = false
         m.selb.text = 'V'
         m.ed_drop_fold(m)
      endif
      if m.EDtest == trim(m.ef.value)
         return
      else
         m.EDtest = trim(m.ef.value)
      endif

      if m.set_query(m.ef.value)	= 1
         if not m.ED_onfound == ""
            d =  'this.parent.parent.' +  m.ED_onfound
            &d()
         endif //ED_found
      else
         if not m.ED_onfailed == ""
            d =  'this.parent.parent.' + m.ED_onfailed
            &d()
         endif //ED_failed
      endif
	return
	  
	function infogrid_onleftmousedown
      this.parent.selected = false
      this.parent.x_selected(this.parent)
	return
	
	function x_selected(ed)
      if ed.selected == ed.EF.value;return;endif
      ed.selected = true
      ed.ptimer.enabled = false
      ed.EF.value = ed.infoQ.rowset.fields[2].value
      this.parent.dropped = false
      ed.ed_drop_fold(ed)
      if not this.ed_onselect == ""
         d = 'this.parent.' + this.ed_onselect
         &d()
      endif
	return

	function selb_onleftmousedown
      this.parent.dropped = false
      this.parent.ed_drop_fold(this.parent)
	return
	
	function ed_drop_fold(ed)
      ed.dropped = true
      if ed.dropdown < 1;return;endif
      if ed.selb.text = '^'
         ed.height = ed.ef.height * 125/100
         ed.selb.text = 'V'
      else
			ed.infogrid.width = ed.width * 95/100
         ed.height = ed.dropdown
         ed.infogrid.height := ed.height - ed.ef.height
         ed.selb.text = '^'
      endif
	return

endclass

function rowup
   if type(' _App.navrow') <> 'O';return;endif
   if not _App.navrow.endofset
      _App.navrow.next( -1)
   endif
   if _App.navrow.endofset
      _App.navrow.next( )
   endif
return

function rowdown
   if type(' _App.navrow') <> 'O';return;endif
   if not _App.navrow.endofset
      _App.navrow.next( )
   endif
return

function ADO_example_form

/*

Example ADO form:		
		
** END HEADER -- do not remove this line
//
// Generated on 06/04/2021
//
parameter bModal
local f
f = new ENTRYDROP5ADOForm()
if (bModal)
   f.mdi = false // ensure not MDI
   f.readModal()
else
   f.open()
endif

class ENTRYDROP5ADOForm of FORM
   set procedure to :sbaccts11:EntryDrop5.cc additive
   with (this)
      height = 26.2273
      left = 98.1429
      top = 7.8636
      width = 75.0
      text = "ENTRYDROP5 with ADO"
   endwith

   this.ADODATABASE1 = new ADODATABASE(this)
   with (this.ADODATABASE1)
      left = 1.0
      width = 10.0
      height = 1.0
      connectionString = 'Your connection string here...'
      active = true
   endwith

   this.ADOQUERYX = new ADOQUERY(this)
   with (this.ADOQUERYX)
      left = 56.0
      top = 6.0
      width = 8.0
      height = 1.0
      database = form.adodatabase1
      connected = true
      sql = "select suppcode,name from supp where upper(name) like :x"
      with (parameters["x"])
         type = "VarChar"
         value = "%"
      endwith
      active = true
   endwith

   this.ENTRYDROP51 = new ENTRYDROP5(this)
   with (this.ENTRYDROP51)
      onOpen = class::ENTRYDROP51_ONOPEN
      left = 0.0
      top = 6.9091
      width = 52.0
      height = 12.5909
   endwith

   with (this.ENTRYDROP51.INFOGRID)
      height = 12.4545
      left = 0.0
      top = 0.0
      width = 50.5714
   endwith

   this.TEXT1 = new TEXT(this)
   with (this.TEXT1)
      height = 3.5
      left = 2.0
      top = 2.5
      width = 44.0
      text = "This is wher the info shows..."
   endwith


   

   function ENTRYDROP51_onOpen()
    with (this)
		infoQ      		:= form.adoqueryx
		qparam     		:= 'x'
		ado = true // default
		ED_onFound  := '' // or whatever function you want
		ED_onfailed  := '' // or whatever function you want
		ED_OnSelect := 'Show_code' // or whatever function you want
		ED_OnGotFocus := '' // or whatever function you want
		ContainedIn := false // default 
		Overwrite := false // default 
		dropdown = this.height // 15 default 
	endwith  
   return
		

	function Show_code
		form.text1.text = trim(form.adoqueryx.rowset.fields[1].value)
		form.text1.text += chr(10) + trim(form.adoqueryx.rowset.fields[2].value)
	return

endclass


// end of example ADO form

*/
return

function BDE_example_form

/*
example BDE form:

** END HEADER -- do not remove this line
//
// Generated on 06/04/2021
//
parameter bModal
local f
f = new EntryDrop5Form()
if (bModal)
   f.mdi = false // ensure not MDI
   f.readModal()
else
   f.open()
endif

class EntryDrop5Form of FORM
   set procedure to :sbaccts11:EntryDrop5.cc additive
   with (this)
      height = 32.6364
      left = 117.0
      top = 0.0
      width = 105.4286
      text = ""
   endwith

   this.DATABASE1 = new DATABASE(this)
   with (this.DATABASE1)
      left = 8.0
      top = 3.0
      width = 7.0
      height = 1.0
      databaseName = "Your databasename here..."
      active = true
   endwith

   this.QUERY1 = new QUERY(this)
   with (this.QUERY1)
      left = 8.0
      top = 5.0
      width = 5.0
      height = 1.0
      database = form.database1
      sql = "select custcode,name,first,add1 from cust.DBF where upper(name) like :xx"
      params["xx"] = "%"
      active = true
   endwith

   this.ENTRYDROP51 = new ENTRYDROP5(this)
   with (this.ENTRYDROP51)
      onOpen = class::ENTRYDROP51_ONOPEN
      left = 0.0
      top = 8.0
      width = 53.0
      height = 20.5
   endwith

   with (this.ENTRYDROP51.INFOGRID)
      height = 19.8636
      left = 0.0
      top = 0.0
      width = 50.5714
   endwith

   this.TEXT1 = new TEXT(this)
   with (this.TEXT1)
      height = 5
      left = 5.0
      top = 1.5
      width = 83.0
      text = "Details will be here"
   endwith


	
	function ENTRYDROP51_onOpen()
	with(this)
		infoQ      		:= form.query1
		qparam     		:= 'xx'
		ado = false
		ED_onFound  := '' // or whatever function you want
		ED_onfailed  := '' // or whatever function you want
		ED_OnSelect := 'Show_code' // or whatever function you want
		ED_OnGotFocus := '' // or whatever function you want
		ContainedIn := false // default 
		Overwrite := false // default 
		dropdown = this.height//15 // default 
	endwith   
   return


	function Show_code
		form.text1.text = trim(form.query1.rowset.fields[2].value)
		form.text1.text += chr(10) + trim(form.query1.rowset.fields[3].value)
		form.text1.text += chr(10) + trim(form.query1.rowset.fields[4].value)
	return
	endclass
	// end of bde example form
	*/
return


