/*
   kmScheduler.h
   Questo  il settaggio delle definizioni per le stringhe usate
   nelle form del Calendar/Scheduler creato da Ken Mayer. L'idea 
   di mettere tutte le stringhe visualizzate dall'utente in questo
   file come costanti usando il comando del preprocessore #DEFINE.
   Nel codice delle quattro form, le stringhe saranno rimpiazzate
   dalla costante appropriata presente in questo file.
   Lo scopo  quello di dare la possibilita' ad ogni utente di
   poter tradurre nella sua lingua madre queste stringhe senza 
   essere costretto ad usare solo la lingua Inglese.

   Ognuna delle quattro form descritte sotto deve contenere
   all'inizio il seguente comando:
       #INCLUDE <kmScheduler_Italiano.h>
   se si vuole cambiare lingua, si include un altro file:
       #INCLUDE <kmScheduler_English.h> oppure
       #INCLUDE <kmScheduler_German.h>  oppure 
       #INCLUDE <kmScheduler_Dutch.h> ecc. ecc.

   Le forms sono:
       kmScheduler.wfm
       kmSchedEvent.wfm
       km24Time.wfm
       kmSmallCal.wfm

   Chi vuole tradurre questo file in una lingua che richiede l'uso
   di caratteri speciali come ad esempio la "u" maiuscola con umlaut,
    preferibile usare chr( 252 ), come in: "abcde"+chr(252)+"test".
*/ 

// ------------------------------------------------------------------
// For the main calendar form: kmScheduler.wfm
// ------------------------------------------------------------------
// Form's text property:
#DEFINE SCHEDFORMTEXT             "Calendario/Agenda"

// UI -- User Interface -- speedtips for controls:
#DEFINE MONTHBUTTONTEXT           "Mese"
#DEFINE NEXTMONTHBUTTONSPEEDTIP   "Mese Successivo"
#DEFINE PREVMONTHBUTTONSPEEDTIP   "Mese Precedente"
#DEFINE YEARBUTTONTEXT            "Anno"
#DEFINE NEXTYEARBUTTONSPEEDTIP    "Anno Successivo"
#DEFINE PREVYEARBUTTONSPEEDTIP    "Anno Precedente"
#DEFINE TODAYBUTTONTEXT           "Oggi"
#DEFINE TODAYBUTTONSPEEDTIP       "Vai alla data di Oggi"
#DEFINE WEEKVIEWBUTTONTEXT        "Vista Settimanale"
#DEFINE WEEKVIEWBUTTONSPEEDTIP    "Cambia in Vista Settimanale"
#DEFINE WEEKBUTTONTEXT            "Settimana"
#DEFINE NEXTWEEKBUTTONSPEEDTIP    "Settimana Successiva"
#DEFINE PREVWEEKBUTTONSPEEDTIP    "Settimana Precedente"
#DEFINE MONTHVIEWBUTTONTEXT       "Vista Mensile"
#DEFINE MONTHVIEWBUTTONSPEEDTIP   "Cambia in Vista Mensile"
#DEFINE MOREBUTTONUPSPEEDTIP      "Vedi i cinque eventi precedenti"
#DEFINE MOREBUTTONDOWNSPEEDTIP    "Vedi i cinque eventi successivi"

// canOpen event:
#DEFINE OPENFORMERROR             "Impossibile aprire la Form"
#DEFINE DATEEXOPENERROR           "Impossibile aprire :dUFLP:DateEx.cc!"
#DEFINE HOLIDAYOPENERROR          "Impossibile aprire :dUFLP:Holiday.cc!"
#DEFINE BDEALIASOPENERROR         "Impossibile aprire :dUFLP:BDEAlias.cc!"
// note the trailing space before the quote -- keep it!
#DEFINE CREATEALIASERROR          "Impossibile creare BDE Alias: "
#DEFINE CREATETABLEERROR          "Impossibile creare la tabella: "
#DEFINE TABLELEVELERROR           "Il Livello delle Tabelle deve essere configurato a 7 -- occorre cambiarlo con BDE Administrator!"
#DEFINE CREATEINDEXESERROR        "Impossibile creare indici per: "
// Holiday names:
#DEFINE ADVENTNAME                "Avvento"
#DEFINE EASTERNAME                "Pasqua"
#DEFINE NEWYEARNAME               "Anno Nuovo"
#DEFINE VALENTINENAME             "S.Valentino"
#DEFINE STPATRICKNAME             "S.Patrizio"
#DEFINE APRILFOOLNAME             "Primo Aprile"
#DEFINE HALLOWEENNAME             "Halloween"
#DEFINE CHRISTMASNAME             "Natale"
#DEFINE NEWYEAREVENAME            "Capodanno"


// ------------------------------------------------------------------
// kmSchedEvent.wfm
// ------------------------------------------------------------------
// UI Interface:
// Form text:
#DEFINE SCHEDEVENTFORMTEXT        "Dettagli Evento Individuale"
// Tabbox1 dataSource -- don't translate the word "ARRAY":
#DEFINE TABBOXDATASOURCE          [ARRAY {"Evento Corrente","Giorno dell' Evento"}]
// Title text:
#DEFINE TITLETEXTEVENTS           "Evento"
// Grid column headings:
#DEFINE GRIDCOLUMN1HEADING        "Ora"
#DEFINE GRIDCOLUMN2HEADING        "Evento"
#DEFINE GRIDCOLUMN3HEADING        "Ripetizione"
// Text/TextLabel controls on form:
#DEFINE EVENTTITLETEXT            "Titolo Evento:"
#DEFINE DETAILTEXT                "Dettagli:"
#DEFINE LOCATIONTEXT              "Locazione:"
#DEFINE DATETEXT                  "Data:"
#DEFINE STARTTIMETEXT             "Ora Inizio:"
#DEFINE ENDTIMETEXT               "Ora Fine:"
#DEFINE REPEATTYPETEXT            "Tipo Ripetizione:"
#DEFINE REPEATEVENTSTEXT          "Eventi Ripetuti"
#DEFINE EVENTNOTREPEATTEXT        "Questo evento non si ripete"
#DEFINE STATUSTEXT                "Stato:"
// Note the HTML formatting here -- leave those, but move as appropriate:
#DEFINE INFOTEXT                  "La <b>Data</b>  richiesta, e sar "+;
                                  "la data selezionata per l' evento. "+;
                                  "<b>Ora Inizio</b> e <b>Ora Fine</b> "+;
                                  "Sono richieste se l'evento  'giornaliero' "+;
                                  "L' orario deve essere in formato 24 ore "+;
                                  "(per il pomeriggio, aggiungere 12 -- es., 1:00 "+;
                                  "pm equivale alle 13:00)."
// Checkbox:
#DEFINE ALLDAYCHECKTEXT           "Ogni Giorno ?"
// Buttons:
#DEFINE CHANGEDATEBUTTONSPEEDTIP  "Cambia Data"
#DEFINE STARTTIMESPEEDTIP         "Cambia Ora Inizio"
#DEFINE ENDTIMESPEEDTIP           "Cambia Ora Fine"
// Comboboxes:
#DEFINE REPEATTYPE1               "Nessuno"
#DEFINE REPEATTYPE2               "Giornaliero"
#DEFINE REPEATTYPE3               "Settimanale"
#DEFINE REPEATTYPE4               "Mensile"
#DEFINE REPEATTYPE5               "Annuale"
#DEFINE STATUSCOMBO1              "Aperto"
#DEFINE STATUSCOMBO2              "Completato"
// On 'repeat' containers:
#DEFINE EVERYTEXT                 "Tutto"
#DEFINE ENDONTEXT                 "Fine a:"
#DEFINE REPEATSPINERROR           "Da 1 a 99"
#DEFINE ENDDATEBUTTONSPEEDTIP     "Cambia Data"
#DEFINE DAYSTEXT                  "Giorni"
#DEFINE WEEKSTEXT                 "Settimane"
#DEFINE MONTHSTEXT                "Mesi"
#DEFINE YEARSTEXT                 "Anni"
#DEFINE DESCRIPTTEXT              "Il giorno ?? di ogni mese"
#DEFINE REPEATONTEXT              "Ripete in:"
// Delete method:
#DEFINE DELETEQUESTIONTEXT        "Si vuole Annullare solo l' evento corrente (Si), "+;
                                  "o tutte le occorrenze di questo evento (No)?"
#DEFINE REPEATINGEVENTTITLE       "Ripetizione Evento"
#DEFINE UNEXPECTEDERRORMSG        "Errore inaspettato: "
#DEFINE ERRORTITLE                "Errore"
// Save Method:
#DEFINE SAVEREPEATQUESTIONTEXT    "Le modifiche devono interessare solo l' evento corrente "+;
                                  "(SI), o tutte le occorrenze di questo evento (No)?"
#DEFINE TITLEREQUIREDTEXT         "Il Titolo dell'Evento  richiesta!"
#DEFINE CANNOTSAVETITLE           "Impossibile Salvare!"
#DEFINE EVENTREQUIREDTEXT         "La Data dell'evento  richiesta!"
#DEFINE STARTTIMEREQUIREDTEXT     "L'Ora di Inizio dell'evento  richiesta!"
#DEFINE ENDTIMEREQUIREDTEXT       "L'Ora di Fine dell'evento  richiesta!"
#DEFINE ENDDATEREQUIREDTEXT       "Per la ripetizione dell'evento,  richiesta una Data di Fine"
#DEFINE DAYOFWEEKREQUIREDTEXT     "Un giorno della settimana deve rssere scelto "+;
                                  "per la ripetizione dell'Evento"
// Week Day checkbox change:
#DEFINE WEEKDAYERROR1             "Data corrente selezionata: "
#DEFINE WEEKDAYERROR2             " "
#DEFINE WEEKDAYERROR3             ", impossibile deselezionare."
#DEFINE WEEKDAYERRORTITLE         "questo non si pu fare"
// TimeEntryfield class:
#DEFINE TIMEENTRYSPEEDTIP         "Immettere l' orario in formato 24 ore"
#DEFINE TIMEENTRYHOURERRORTEXT    "Immettere un valore da 0 a 23"
#DEFINE TIMEENTRYHOURERRORTITLE   "Ora non valida"
#DEFINE TIMEENTRYMINUTEERRORTEXT  "Immettere un valore da 0 a 59"
#DEFINE TIMEENTRYMINUTEERRORTITLE "Minuti non validi"

// ------------------------------------------------------------------
// km24Time.wfm
// ------------------------------------------------------------------
#DEFINE TIMEFORMTEXT              "Scelta Ora"
#DEFINE HOURTEXT                  "Ora"
#DEFINE MINUTETEXT                "Minuti"
#DEFINE TIMEFORMDESCRIPTIONTEXT   "L' orario  in formato 24 ore, quindi "+;
                                  "per il pomeriggio, aggiungere 12. Esempio, "+;
                                  "2:00 pm appare come 14:00. "+;
                                  "Mezzanotte  '00'."
#DEFINE OKBUTTONTEXT              "Ok"
#DEFINE TIMEOKBUTTONSPEEDTIP      "Accetta l' ora corrente"
#DEFINE CANCELBUTTONTEXT          "Annulla"
#DEFINE TIMECANCELBUTTONSPEEDTIP  "Ritorna al valore scelto precedentemente"

// ------------------------------------------------------------------
// kmSmallCal.wfm
// ------------------------------------------------------------------
#DEFINE CALFORMTEXT               "Scelta Data"
#DEFINE DATEOKBUTTONSPEEDTIP      "Accetta la data corrente"

// ------------------------------------------------------------------
// :dUFLP:kenCal3.cc (on kmSmallCal.wfm)
// ------------------------------------------------------------------
#DEFINE KCYEARMINUS10BUTTONSPEEDTIP "10 Anni Indietro"
#DEFINE KCYEARPLUS10BUTTONSPEEDTIP  "10 Anni Avanti"
#DEFINE KCPREVYEARBUTTONSPEEDTIP    "Anno Precedente"
#DEFINE KCNEXTYEARBUTTONSPEEDTIP    "Anno Successivo"
#DEFINE KCMONTHMINUS3BUTTONSPEEDTIP "3 Mesi Indietro"
#DEFINE KCMONTHPLUS3BUTTONSPEEDTIP  "3 Mesi Avanti"
#DEFINE KCPREVMONTHBUTTONSPEEDTIP   "Mese Precedente"
#DEFINE KCNEXTMONTHBUTTONSPEEDTIP   "Mese successivo"
#DEFINE KCTODAYBUTTONTEXT           "Oggi"
#DEFINE KCTODAYBUTTONSPEEDTIP       "Vai alla Data di Oggi"

// ------------------------------------------------------------------
// kmSchedColor.wfm
// ------------------------------------------------------------------
// This one is actually in kmScheduler.wfm
#DEFINE CHANGECOLORBUTTONSPEEDTIP     "Cambia Colore ai Bottoni"
// The rest are in kmSchedColor.wfm
#DEFINE COLORFORMTITLE                "Cambia Colori"
#DEFINE HOLIDAYBUTTONTEXT             "Festivi"
#DEFINE CURRENTDAYBUTTONTEXT          "Giorno Selezionato"
#DEFINE DEFAULTDAYBUTTONTEXT          "Standard"
#DEFINE TEXTCOLORBUTTONTEXT           "T"
#DEFINE BACKGROUNDCOLORBUTTONTEXT     "B"
#DEFINE TEXTCOLORBUTTONSPEEDTIP       "Cambia colore al testo"
#DEFINE BACKGROUNDCOLORBUTTONSPEEDTIP "Cambia colore di sfondo"

