function MSDialog( cPrompt, cTitle, cDefault, nXPos, nYPos )
   /*
      MsDialog.prg
      This little function calls the Visual BASIC dialog
      that allows you to get info from your user, without
      requiring that you build your own dialog ...

      This was posted by Ivar B. Jessen on the dBASE
      newsgroups in April, 2007, and turned into a dBASE
      function (Ivar had reposted a function that Rich Muller
      originally posted, and he had hardcoded everything), by Ken Mayer.

      Usage: MSDialog( <cPrompt>[, <cTitle>[, <cDefault>[, <nXPos>[, <nYPos>]]]] )

      Examples:
         ? MSDialog( "Enter name:", "Give Me A Name", "Put your name here" )
         cName = MSDialog( "Enter name:", "Give Me A Name", "Put your name here" ) 

      Parameters:
      cPrompt: (Required) prompt on dialog to left of entry area
      cTitle: text in dialog window for titlebar
      cDefault: value that appears in the entryfield as a default
                string
      nXPos:  position in twips from the left edge of the screen
              that the left of the dialog appears ... if left out,
              this will be centered
      nYPos:  position in twips from the top of the screen that
              the left of the dialog appears. If left out,
              this will be positioned approximately 1/3 of the way 
              down the screen.
            It's probably a good idea to just let Windows center
            the dialog, but you can set positioning if you want.

      If you decide to skip one of the character parameters,
      you need to pass it anyway, i.e.:
         MsDialog( "Enter Name:", "", "Default Name" )
      
   */
   local cStr, oSC, cStrCode, cLF
   cLF = chr(13)+chr(10)

   oSC = new OleAutoClient( "MSScriptControl.ScriptControl" )
   oSC.language = "VBScript"

   cStrCode = 'function NameMe()'+cLF+;
              'strVal = InputBox( "'+cPrompt+'"'
   // deal with optional parameters
   if pCount() => 2 // titlebar text?
      cStrCode += ',"'+cTitle+'"'
      if pCount() => 3 // default value?
         cStrCode += ',"'+cDefault+'"'
         if pCount() => 4
            if type( 'nXPos' ) == "C"
               nXPos = val( nXPos )
            endif
            cStrCode += ','+nXPos
            if pCount() => 5
               if type( 'nYPos' ) == "C"
                  nYPos = val( nYPos )
               endif
               if nYPos > 0
                  cStrCode += ','+nYPos
               endif
            endif // 5
         endif // 4
      endif // 3
   endif // 2
   cStrCode += ')'+cLF
   cStrCode += ' NameMe = strVal'+cLF+;
               'End function'

   oSC.AddCode( cStrCode )
   cStr = oSC.run( "NameMe" )

   release object oSC
   oSC = null

return cStr
// end of function MSDialog