/*
   -----------------------------------------------------------------------------
   autocomplete.cc Version 1.3
   Authors..: Akshat Kapoor,Omar Mohammed, Ken Mayer,Tom
   Date.....: 22 April 2020
   Notes....: This file contains auto_complete entryfield class.
 
              First of All I would like to thank Eric Wu for raising demand 
              for this custom class on newsgroup.
              
              Then I would like to thank Omar and Tom for giving us working Example
              Then I would like to thank Ken Mayer for providing us 
              with autofill_entryfield.cc Whenever I got stuck during coding I would 
              have a look at how Ken had did this thing in his cc.
              It was a first time for me that an custom class would be declaring a query, listbox etc.
              And Mervyn for pointing out some typical errors like different RDBMS use different syntax
              for limiting the number of rows.
              
              This class is supposed to provide us with matching suggestions 
              in an Entryfield just like Google provides us with suggestions
              But this will have a limited dictionary from the suggestions provided 
              in a table / column
              
              If there are more than 1 matching choices then they will be displayed 
              as listbox just below the control. Using up/down arrow keys one  can select a different choice
              
              Added a property pageno as per Eric's request to make it compatible with 
              tabbox
              
              This class does not work well with datalinked entryfields. 
              For datalinked entryfields try auto_fillentryfield.cc by Ken Mayer.
              It works fine with non datalinked entryfields.
              
              For Best results initial value should be "" or "Initial Value"
              using "Initial Value    " may give incorrect results

               Autocomplete.wfm (A sample form designed and provided by Mervyn is also attached)

              Normally just 1 control would be required on a form but if you are 
              placing more than 1 controls on a form then place them in a single container
              You can place them on 2 different tabboxes but not on 1 form and 1 container.
              
              To place 1 control on form and 1 control in a container you will have to 
              disable the arrowkeys usage of one. 
              form.container1.auto_complete1.use_arrow = false
              In the attached sample form test_auto.wfm I have dealt with this issue.
              You will find there 3 controls on the form with arrow keys functioning in 2 of them.
              
              Arrow keys will have to be compulsorily disabled in the following conditions
              1. Multiple containers for different controls.

              2. Multiple forms with this control open at the same time.
                  
              This control should work on 
              1.  all form metrics 
              2.  BDE & ADO
              3.  Option of match case or not
              4.  Works like an entryfield. Tested with non datalinked entryfields only
                  but should work with datalinked entry fields also
             
   Usage....: set procedure to autocomplete.cc
              ** on a form in the designer, set an instance of 
              ** Auto_Complete on the form. Using the Inspector,
              ** open the form's onOpen event handler in the Source Code
              ** Editor (click "Events" in the inspector, find onOpen,
              ** click the tool button). Add the following code
              ** where appropriate in the function that is created
              ** (the following assumes the standard naming on a form
              ** in the form designer, adding a numeric value to the
              ** end of the name of the control):
              **    form.Auto_complete.dataBase  := "Database object"
              **    form.Auto_complete.tableName := "Table name"
              **    form.Auto_complete.fieldName := "Field name "
              ** If there is no database (the tables are in the same folder
              ** as the application) you can leave it out. Otherwise,
              ** please define the database name.
              ** It is a must in case of using ADO
              
              **  Additional optional settings
              **  form.Auto_complete.matchcase = false
                  if set to true then exact case matching would take place
              **  form.Auto_complete.use_ado   = false
                  if you are using Ado set this to true


              Example -- in the same folder:
                 function form_onOpen()
                   form.Auto_complete.tableName    := "Autofill_Cities"
                   form.Auto_complete.fieldName    := "CityNames"
                 return
                 
              Example 2 -- in a database:
                 function form_onOpen()
                   form.Auto_Complete.database     := "MyApp_Data"
                   form.Auto_Complete.tableName    := "Autofill_Cities"
                   form.Auto_Complete.fieldName    := "CityNames"
                 return

                  A point worth mentioning here is that in case of Database
                  just mentioning the name of the database is not sufficient
                  It should be a active database object. 
                  There are multiple variations of creating a database object 
                  and a database object if required is usually there in the form. 
                  
                  Same is with ADOdatabase objects.
                  
                  It is worth mentioning here that if we drop a table on the form from 
                  a database (say dbasesamples) 2 objects are created on the form
                  1. A database object 
                  2. A query
                  Both are on top of each other so unless you are looking for it 
                  you will not observe them.
                  It is this database object that will be use in this code.
                                    
                  The ADO version is also working well but due to working of like in ADO
                  (atleast in mariaDB) matchcase does not have any effect                   
   -----------------------------------------------------------------------------
*/

class Auto_complete(parentObj) of ENTRYFIELD(parentObj) custom
   with (this)
      onGotFocus  := class::Auto_complete_ONGOTFOCUS
      onLostFocus := class::Auto_complete_ONLOSTFOCUS
      key         := class::Auto_complete_KEY
      onKey       := class::Auto_complete_ONKEY
      onOpen      := class::auto_complete_OnOpen
      onClose     := {;on key;_app.autocomplete=null}
      value       := ""
   endwith
   // custom properties
   this.fieldName = ""
   this.tableName = ""
   this.dataBase  = ""
   this.matchcase = false
   this.use_ado   = false
   this.use_arrow = true

   function Auto_complete_OnOpen
      // Two things will be required
      //Set up query to get data and set up list box.
      //This section is for creation of necessary query 
      if empty(this.fieldName)  or empty(this.tableName)
          msgbox( "No links provided for datasource of Auto complete, It will not work", "Auto Complete error", 16 )
          form.close()
      endif
      
      if this.use_ado and empty(this.database)
         msgbox("No Ado database specified for datasource Hence cannot continue", "Auto Complete error", 16 )
         form.close()
      endif
      
      if not empty(this.database)
         if "database" $ lower(this.database.baseclassname)
            //all okay
         else
            msgbox("database supplied is not an active database")
         endif
      endif
      //To setup database connections and setup queries
      if this.use_ado
         //If the end user is using ADO
         this.query           = new adoquery()
         this.query.database  = this.database
         if this.matchcase
            this.query.sql    = [Select distinct ]+this.fieldname + [ from ]
            this.query.sql+= this.tablename + [ where ]+ this.fieldname + [ like :mat_ch order by ]+ this.fieldname 
         else
            //Match case is not required hence converting all to uppercase
            this.query.sql    = [Select distinct ]+this.fieldname + [ from ]
            this.query.sql+= this.tablename + [ where upper(]+this.fieldname+[) like :mat_ch order by upper(]+ this.fieldname +[) ]
         endif
         //I had initially added "Limit 10" to the above queries to limit the number of rows
         //Till Mervyn pointed out that this syntax varies with RDBMS.(https://razorsql.com/articles/firebird_limit_rows.html)
         //So please add it if required 
         this.query.parameters["mat_ch"].type = "Char"
         this.query.parameters["mat_ch"].value = " "
         this.query.requestlive = false
         this.query.active = true
      else
         this.query           = new query()
         if not empty(this.database)
            this.query.database  = this.database
         endif
         if this.matchcase
            this.query.sql    = [Select distinct ]+this.fieldname + [ from ]
            this.query.sql+= this.tablename + [ where ]+ this.fieldname + [ like :mat_ch order by ]+ this.fieldname
            this.query.params["mat_ch"] = ""
            this.query.active = true
         else
         //"select distinct narration,upper(narration) as upfield from narration where upper(narration) like :narr order by upfield"
         //above is a working sql just trying to build it using table names specified by user
            this.query.sql    = [Select distinct ]+this.fieldname+[ ,upper(]+this.fieldname + [) as upfield from ]
            this.query.sql+= this.tablename + [ where upper(]+ this.fieldname + [) like :mat_ch order by upfield]
            this.query.params["mat_ch"] = ""
            this.query.active = true         
         endif      
      endif
      //End of setting up queries section
      
      
      // set up the ListBox control
      // use a listbox and display options if there's more than 1 ...
      oThis = this // reference the entryfield control
      this.list = new listbox(oThis.parent)
      this.list.visible     := false
      this.list.top         := oThis.top+oThis.height
      this.list.left        := oThis.left
      this.list.width       := oThis.width
      this.list.height      := oThis.height*3
      this.list.pageno      := oTHIS.pageno
      
      //In the above line I have set the listbox height to 3 times the entryfield height.
      //Please alter it to suit your need
      
      this.list.ef_name     = oThis.name
      // height is complicated (get position of the bottom of the listbox,
      // if it is > than the bottom of the form, we need to bring it up ...:
      if this.list.top + this.list.height > oThis.parent.height
         this.list.height = oThis.parent.height - this.list.top
      endif
      if this.use_arrow = true
         _app.autocomplete = this.parent
      endif
      //This reference will be set to null when entryfield closes.
      //End of section for setting up listbox.
      return

   function autofill()
      parameters cntrl_name
      part_len = len(this.value)
      add_length = len(ltrim(rtrim(this.list.value))) - part_len
      this.value= this.value + right(ltrim(rtrim(this.list.value)),add_length)
      this.keyboard("{end}")
      backstr = len(this.value) - part_len
      for x = 1 to backstr
         this.keyboard("{shift+leftarrow}")
      endfor
      //This function selects part of the text
      return


   function Auto_complete_onGotFocus()
      if this.use_arrow
         cmd = [on key label dnarrow dnarrow("]+this.name+[")]
         &cmd
         cmd = [on key label uparrow uparrow("]+this.name+[")]
         &cmd      
         //The above commands will change the highlighted option of the listbox
      endif
      return
      
   function Auto_complete_onLostFocus()
      this.list.visible := false
      on key
      //To disable the above mentioned commands
      return

   function Auto_complete_key(nChar, nPosition,bShift,bControl)
      //To check if the user has pressed backspace or space
      this.bspa = false
      if (nchar == 127 or nchar == 8)
         this.bspa = true
      endif
      this.space = false
      if( nChar == 32 )
         this.space = true
      endif
      return true
      
   function Auto_complete_onKey(nChar, nPosition,bShift,bControl)
      if not empty(this.value)
         mado = this.use_ado
         mpartial = iif(this.matchcase,ltrim(rtrim(this.value)),upper(ltrim(rtrim(this.value))))
         if this.space
            mpartial= mpartial + [ ]
         endif
         this.list.onselchange = null         
         if mado
            this.query.parameters["mat_ch"].value = mpartial+[%]
            this.query.requery()
         else
            this.query.params["mat_ch"]   = mpartial+[%]
            this.query.requery()
         endif
         if this.query.rowset.count() >0
            this.aData = new array()
            for i = 1 to this.query.rowset.count()
                this.aData.add( this.query.rowset.fields[1].value.rightTrim().leftTrim() )
                this.query.rowset.next()
            next
            //The code for building an array has been taken from Ken's cc
            // assign listbox dataSource
            this.list.dataSource := "array this.aData"
         endif
         this.list.onselchange = Auto_Complete::list_onSelChange
         if this.query.rowset.count() > 1
            this.list.visible = true
            if (not this.bspa) and (not this.space)
               auto_complete::autofill(this.name)
            endif
            //List box should be visible only if there are more than 1 choices to choose from 
         else
            this.list.visible = false
            if this.query.rowset.count() = 1
               //No need to display listbox if we have only 1 row but autofill still needs to be processes
               if (not this.bspa) and (not this.space)
                  Auto_Complete::autofill(this.name)
               endif
            endif
         endif
      else
         //Make the listbox invisible as the entryfield is blank
         this.list.visible = false
      endif
      return
      
   function LIST_onSelChange()
      //When listbox selection changes through mouse. 
      //Arrow keys do not trigger this event
      cmd= [this.parent.] + this.ef_name + [.value = ltrim(rtrim(this.value))]
      &cmd
      this.visible = false
//      this.parent.keyboard("{end}") To press the end key in the entry field
      cmd = [this.parent.] + this.ef_name + [.keyboard("{end}")]
      &cmd
      return
endclass


function dnarrow()
   //This moves the listbox selection 1 down
   parameters control_name
   R = [_app.autocomplete.]+control_name+[.query.rowset.count()]
   //if form.distinct.rowset.count() >1
   if &R >1
      S = [_app.autocomplete.]+control_name+[.list.count()]
      T = [_app.autocomplete.]+control_name+[.list.cursel]
      //if form.listbox1.count() > form.listbox1.cursel
      if &S > &T
         //form.listbox1.onselchange = null
         //form.listbox1.cursel= form.listbox1.cursel+1
         //form.listbox1.onselchange = form.listbox1_onSelChange
         //The above commands are being executed using macro substitution
         cmd =  [_app.autocomplete.]+control_name+[.list.onSelChange = null]
         &cmd
         cmd = [_app.autocomplete.]+control_name+[.list.cursel = _app.autocomplete.]+control_name+[.list.cursel+1]
         &cmd
         cmd = [_app.autocomplete.]+control_name+[.value = ltrim(rtrim(_app.autocomplete.]+control_name+[.list.value))]
         &cmd
         cmd = [_app.autocomplete.]+control_name+[.list.onselchange = Auto_complete::list_onSelChange]
         &cmd
         cmd = [_app.autocomplete.]+control_name+[.keyboard("{end}")]
         &cmd
      endif
   endif
   return

function uparrow()
   //This moves the listbox selection 1 up
   parameters control_name
   R = [_app.autocomplete.]+control_name+[.query.rowset.count()]
   if &R >1
      T = [_app.autocomplete.]+control_name+[.list.cursel]
      if &T >1
         U = [_app.autocomplete.]+control_name+[.list.onSelChange]
         &U = null
         &T = &T-1
         &U = Auto_complete::list_onSelChange
         cmd = [_app.autocomplete.]+control_name+[.value = ltrim(rtrim(_app.autocomplete.]+control_name+[.list.value))]
         &cmd
         cmd = [_app.autocomplete.]+control_name+[.keyboard("{end}")]
         &cmd
      endif
   endif
   return
