/*
    -----------------------------------------------------------
   custbuttDutch.h
	december 2008
	KvR   Kees van Rooijen  translation into Dutch of Ken Mayer original

	custbuttEnglish.h
    February 9, 1999
    Ken Mayer

     *** Note: you should copy this file to your
     ..\dBASE\PLUS\INCLUDE directory for it to
     be used properly by all of your applications.

    This is an 'include' file with the speedTips and
    message box text for each of the buttons in CUSTBUTT.CC. 
    The idea is that by defining them here, someone using 
    another language can copy this file and translate the 
    text in the .H file, and the only change necessary in
    CUSTBUTT.CC is the #INCLUDE statement to include
    the correct file.

    When translating, make sure you do NOT change the names
    of the constants ...

    *****************
    November 11, 2000
    *****************
    NOTE: If you update your application to use the 
    CUSTBUTT.CC file from dUFLP version 2KC (DUFLP2KC.EXE),
    then you MUST update your .H file -- this is a fix based
    on a discovery that EMPTYTABLE and FILTER strings could
    cause problem in code that used the database object
    emptyTable method, or the rowset object's filter property.
    These strings are defined as EMPTYTABLETEXT and FILTERTEXT
    now, and will not cause a conflict.

    Suggestion by Francesco Navarria, in Italy ...
    -----------------------------------------------------------
*/

// ----------------------------------------------------------
// navigation buttons:
#define TOPTIP                  "Eerste record in tabel"
#define PREVTIP                 "Vorig record"
#define NEXTTIP                 "Volgend record"
#define ENDTIP                  "Laatste record in tabel"

// ----------------------------------------------------------
// editing buttons:
#define ADDTIP                  "Voeg een nieuw record toe"
#define CARRYTIP                "Kopieer deze gegevens naar een nieuw record"
#define EDITTIP                 "Wijzig dit record."
#define SAVETIP                 "Sla dit record op"
#define DELETETIP               "Verwijder dit record"
#define ABANDONTIP              "Hou op met wijzigingen"

// ----------------------------------------------------------
// filter/locate buttons:
#define FILTERTIP               "Zet Filter / Filteren / Stop Filter"
#define LOCATETIP               "Zet Zoeken / Zoekende / Stop Zoeken"

// ----------------------------------------------------------
// clipboard buttons:
#define CUTTIP                  "Knip geselecteerde tekst uit"
#define COPYTIP                 "Kopieer de geselecteerde tekst"
#define PASTETTIP               "Plak vanaf uw klipboord"

// ----------------------------------------------------------
// misc. buttons:
#define CLOSETIP                "Sluit dit formulier"
#define YESTIP                  "Ja"
#define NOTIP                   "Nee"
#define CANCELTIP               "Cancel"
#define QUESTIONTIP             "Vraag? Help?"
#define RUNTIP                  "Ga"
#define INFOTIP                 "Informatie"
#define RESTOREFROMDISKTIP      "Ophalen (opnieuw) van schijf"
#define SAVETODISKTIP           "Sla op schijf op"
#define OPENFILETIP             "Open tabel ..."
#define TOOLBUTTONTIP           "Gereedschap knop"
#define PRINTTIP                "Printen"
#define SEARCHTIP               "Zoeken"
#define SEARCHAGAINTIP          "Ga door met zoeken"
#define REPLACETIP              "Vervangen"
#define EXITTIP                 "Exit"
#define FIRSTPAGETIP            "Eerste pagina"
#define NEXTPAGETIP             "Volgende pagina"
#define PREVIOUSPAGETIP         "Vorige pagina"
#define LIGHTBULBTIP            "Het licht gaat uit"

// ----------------------------------------------------------
// strings used in dialog boxes in CUSTBUTT.CC
// ----------------------------------------------------------

// ----------------------------------------------------------
// This one appears as the title for various dialogs
#define CANTDOIT                "Dit kan niet!"

// ----------------------------------------------------------
// One of these appears anytime we check to see if the rowset
// is null, and is the text in the messagebox
#define NAVNOROWSET             "Kan niet navigeren zonder rowset!"
#define ADDNOROWSET             "Kan geen records toevoegen zonder rowset!"
#define COPYNOROWSET            "Kan geen rijen kopieren van een formulier zonder een rowset!"
#define EDITNOROWSET            "Kan geen rijen wijzigen op een formulier zonder een rowset!"
#define SAVENOROWSET            "Kan geen records opslaan zonder rowset"
#define DELETENOROWSET          "Kan geen records verwijderen zonder rowset"
#define ABANDONNOROWSET         "Kan niet stoppen met wijzigen op een formulier zonder een rowset!"
#define FILTERNOROWSET          "Kan niet filteren in een lege of ontbrekende rowset!"
#define LOCATENOROWSET          "Kan niet zoeken zonder rowset!"

// -----------------------------------------------------------
// this is the title and message when the user attempts
// to navigate or close a form and the data has
// changed ...
#define DATACHANGED             "De gegevens zijn veranderd"
#define SAVECHANGES             "Sla de gewijzigde gegevens nu op?"

// ----------------------------------------------------------
// Title when user can't navigate:
#define CANTNAVIGATE            "Kan niet Navigeren!"

// ----------------------------------------------------------
// Other messages ...
#define INFILTERMODE            "U bent in filter modus"
#define INLOCATEMODE            "U bent in zoeken modus"

#define ATFIRSTROW              "Eerste record in tabel"
#define ATLASTROW               "Laatste record in tabel"

#define ROWISCOPIED             "Rij is gekopieerd -- U bent in Nieuw modus. Maak uw wijzigingen, sla ze op of hou op."

#define NOTEDITING              "Kan wijzigen/toevoegen niet opgeven als u niet aan het wijzigen/toevoegen was"

#define ROWLOCKED               "Record wordt door een andere gebruiker gewijzigd. Probeer het later nogmaals."

#define KEYVIOLATION            "Sleutel (Key) Fout - Deze sleutel bestaat al"
#define UNKNOWNERROR            "Onbekende fout -- "

#define DELETEYESNO             "U staat op het punt dit record te verwijderen" + CHR(13) + "Klik op Ja als bevestiging."
#define NOTHINGTODELETE         "Niets te verwijderen!"

#define ABANDONWILLCANCELFILTER "De rij opgeven en verlaten veroorzaakt een Stop Filter!"
#define ABANDONWILLCANCELLOCATE "De rij opgeven en verlaten veroorzaakt een Stop Zoeken!"
#define NOTHINGTOABANDON        "Kan wijzigen/toevoegen niet opgeven als u niet aan het wijzigen/toevoegen was!"

#define NOMATCH                 "Niets gevonden"
#define EXITFROMFILTER          "Exit filter modus!"
#define NOMOREMATCHES           "Geen verdere records!"

#define CANTSEARCHINMEMO        "Kan niet zoeken in een memo veld!"
#define CANTFILTERINMEMO        "Kan niet filteren in een memo veld!"

// ------------------------------------------------------------
// Misc Titles
#define CANTADDROW              "Kan geen nieuwe rij toevoegen!"
#define CANTCOPYROW             "Kan de rij niet kopieren!"
#define COPYCOMPLETE            "Klaar met kopieren!"
#define CANTEDITROW             "Kan de rij niet wijzigen!"
#define CANTSAVEROW             "Kan de rij niet opslaan!"
#define NOCHANGES               "Geen wijzigingen om op te slaan!"
#define CANTDELETEROW           "Kan records niet verwijderen!"
#define ALERT                   "Pas Op!"
#define EMPTYTABLETEXT          "Lege tabel!"
#define CANCELFILTER            "Hou op met Filter?"
#define CANCELLOCATE            "Hou op met Zoeken?"
#define CANTABANDONROW          "Kan de rij niet loslaten!"
#define CANTSETFILTER           "Kan niet filteren!"
#define FILTERTEXT              "Filter!"
#define CANTSEARCH              "Kan niet beginnen met zoeken!"
#define SEARCH                  "Zoeken!"

// -----------------------------------------------------------
// kmRowState -- states:
#define STATECLOSED             "Gesloten"
#define STATEVIEW               "Bekijken" 
#define STATEEDIT               "Wijzigen"
#define STATEAPPEND             "Nieuw"
#define STATEFILTER             "Filter"
#define STATELOCATE             "Zoeken"

// -----------------------------------------------------------
// End of header file: custButtDutch.h
// -----------------------------------------------------------

