/*
    -----------------------------------------------------------
    custbuttGerman.h
    February 25, 1999
    Ken Mayer
      Norwegian Translation of "custButtEnglish.h" 
      by (*Lysander*) Soest

     *** Note: you should copy this file to your
     ..\Visual dBASE\INCLUDE directory for it to
     be used properly by all of your applications.

    This is an 'include' file with the speedTips and
    message box text for each of the buttons in CUSTBUTT.CC. 
    The idea is that by defining them here, someone using 
    another language can copy this file and translate the 
    text in the .H file, and the only change necessary in
    CUSTBUTT.CC is the #INCLUDE statement to include
    the correct file.

    When translating, make sure you do NOT change the names
    of the constants ...

    *****************
    November 11, 2000
    *****************
    NOTE: If you update your application to use the 
    CUSTBUTT.CC file from dUFLP version 2KC (DUFLP2KC.EXE),
    then you MUST update your .H file -- this is a fix based
    on a discovery that EMPTYTABLE and FILTER strings could
    cause problem in code that used the database object
    emptyTable method, or the rowset object's filter property.
    These strings are defined as EMPTYTABLETEXT and FILTERTEXT
    now, and will not cause a conflict.

    Suggestion by Francesco Navarria, in Italy ...
    **********************************************************
    *** WARNING: If you are not using an ANSI language driver
    *** for your tables (at the Command window: ? LDRIVER()
    *** it should be obvkous) or have the setting:
    ***  LDRIVER=WINDOWS in your VDB.INI file (under the
    *** [CommandSettings] heading) do NOT attempt save
    *** this file ... you can wipe out the upper ANSI characters
    *** used. 
    **********************************************************
    ---------------------------------------------------------
*/

// ----------------------------------------------------------
// navigation buttons:
                                //"First row in rowset"
#define TOPTIP                  "Erster Datensatz der Auswahl"
                                //"Previous row in rowset"
#define PREVTIP                 "Vorheriger Datensatz der Auswahl"
                                 //"Next row in rowset"
#define NEXTTIP                 "Nchster Datensatz der Auswahl" 
                                //"Last row in rowset"
#define ENDTIP                  "Letzter Datensatz der Auswahl"

// ----------------------------------------------------------
// editing buttons:
                                //"Add new row"
#define ADDTIP                  "Datensatz hinzufgen" 
                                //"Copy data to a new Row"
#define CARRYTIP                "Daten in neuen Datensatz kopieren"
                                //"Edit current row"
#define EDITTIP                 "Diesen Datensatz bearbeiten"
                                //"Save current row"
#define SAVETIP                 "Diesen Datensatz speichern"
                                //"Delete current row"
#define DELETETIP               "Diesen Datensatz lschen"
                                //"Abandon changes to row"
#define ABANDONTIP              "nderungen verwerfen"

// ----------------------------------------------------------
// filter/locate buttons:
                                //"Filter/Run/Clear Filter"
#define FILTERTIP               "Filter/Start/Filter lschen"
                                //"Locate/Run/Clear Locate"
#define LOCATETIP               "Suchen/Start/Suchen lschen"

// ----------------------------------------------------------
// clipboard buttons:
                                //"Cut selected text"
#define CUTTIP                  "Ausgewhlten Text ausschneiden"
                                //"Copy selected text"
#define COPYTIP                 "Ausgewhlten Text kopieren"
                                //"Paste from clipboard"
#define PASTETTIP               "Aus Zwischenablage einfgen"

// ----------------------------------------------------------
// misc. buttons:
                                //"Close this form"
#define CLOSETIP                "Dieses Formular schlieen"
                                //"Yes"
#define YESTIP                  "Ja"
                                //"No"
#define NOTIP                   "Nein"
                                //"Cancel"
#define CANCELTIP               "Abbruch"
                                //"Question? Help?"
#define QUESTIONTIP             "Frage? Hilfe?"
                                //"Run"
#define RUNTIP                  "Start"
                                //"Information"
#define INFOTIP                 "Information"
                                //"Restore from disk"
#define RESTOREFROMDISKTIP      "Wiederherstellen von Platte" 	// for Harddisks
                                //"Save to disk"
#define SAVETODISKTIP           "Auf Platte speichern"			// for Harddisks
                                //"Open file ..."
#define OPENFILETIP             "Datei ffnen..."
                                //"Tool Button"
#define TOOLBUTTONTIP           "Werkzeugschalter"
                                //"Print"
#define PRINTTIP                "Drucken"
                                //"Search"
#define SEARCHTIP               "Suchen"
                                //"Continue search"
#define SEARCHAGAINTIP          "Suche fortsetzen"
                                //"Replace"
#define REPLACETIP              "Ersetzen"
                               //"Exit"
#define EXITTIP                 "Verlassen" 	// for formulars; for programs it would be more like
 														   // "Beenden"
                                //"First Page"
#define FIRSTPAGETIP            "Erste Seite"
                                //"Next Page"
#define NEXTPAGETIP             "Nchste Seite"
                                //"Previous Page"
#define PREVIOUSPAGETIP         "Vorherige Seite"
                                //"The Light Goes Off"
#define LIGHTBULBTIP            "Das Licht geht aus"

// ----------------------------------------------------------
// strings used in dialog boxes in CUSTBUTT.CC
// ----------------------------------------------------------

// ----------------------------------------------------------
// This one appears as the title for various dialogs
                                //"Can't do it!"
#define CANTDOIT                "Das kann ich nicht!"

// ----------------------------------------------------------
// One of these appears anytime we check to see if the rowset
// is null, and is the text in the messagebox
                                //"Cannot Navigate with no rowset!"
#define NAVNOROWSET             "Ohne Datensatz-Bereich kann ich mich nicht bewegen!"
                                //"Cannot add rows with no rowset!"
#define ADDNOROWSET             "Ohne Datensatz-Bereich kann ich nix anfgen!"
                                //"Cannot copy rows on a form without a rowset!"
#define COPYNOROWSET            "Ohne Datensatz-Bereich kann ich keine Datenstze einsetzen!"
                                //"Cannot update rows on a form without a rowset!"
#define EDITNOROWSET            "Ohne Datensatz-Bereich kann ich keine Datenstze bearbeiten!"
                                //"Cannot save changes to rows on a form without a rowset!"
#define SAVENOROWSET            "Ohne Datensatz-Bereich kann ich keine nderungen speichern!"
                                //"Cannot save delete rows on a form without a rowset!"
#define DELETENOROWSET          "Ohne Datensatz-Bereich kann ich nix lschen!"
                                //"Cannot abandon changes to rows on a form without a rowset!"
#define ABANDONNOROWSET         "Ohne Datensatz-Bereich kann ich keine nderungen verwerfen!"
                                //"Cannot filter an empty or missing rowset!"
#define FILTERNOROWSET          "Einen leeren oder gar nicht vorhandenen Datensatz-Bereich "+;
                                "kann ich nicht filtern!"
                                //"Cannot perform a locate with no rowset!"
#define LOCATENOROWSET          "Ohne Datensatz-Bereich kann ich nix suchen!"

// -----------------------------------------------------------
// this is the title and message when the user attempts
// to navigate or close a form and the data has
// changed ...
                                //"Data has changed"
#define DATACHANGED             "Die Daten wurden gendert!"
                                //"Save changes before leaving record?"
#define SAVECHANGES             "nderung am Datensatz vorher speichern?"

// ----------------------------------------------------------
// Title when user can't navigate:
                                //"Can't Navigate!"
#define CANTNAVIGATE            "Ich kann den Datensatzzeiger nicht bewegen!"

// ----------------------------------------------------------
// Other messages ...
                                //"You are in filter mode"
#define INFILTERMODE            "Du bist im Filter-Modus"
                                //"You are in locate mode"
#define INLOCATEMODE            "Du bist im Such-Modus"
                                //"At first row in rowset"
#define ATFIRSTROW              "Erster Datensatz des Bereichs"
                                //"At last row in rowset"
#define ATLASTROW               "Letzter Datensatz des Bereichs"
                                //"Row is copied -- you are in append mode. Make changes and save or abandon new row."
#define ROWISCOPIED             "Datensatz kopiert -- Du bist im Anfge-Modus. Nimm die nderungen "+;
                                "vor und speichere oder verwerfe dann den Datensatz."

#define ROWLOCKED               "Row is being edited by another. Try again later."
                                //"Cannot Save edits/new row when you weren't editing/adding"
#define NOTEDITING              "Kann nderungen/neuen Datensatz nicht speichern, da du weder etwas "+;
                                "gendert, noch hinzugefgt hast."
                                //"Key Violation - That Key already exists."
#define KEYVIOLATION            "Schlsselfeld ungltig! Dieser Schlssel existiert bereits!"
                                //"Unknown error -- "
#define UNKNOWNERROR            "Unbekannter Fehler -- "
                                //"You are about to delete the current row." + CHR(13) + "Click Yes to delete the current row."
#define DELETEYESNO             "Du bist dabei, diesen Datensatz zu lschen! "+chr(13)+;
                                "Mit -Ja- wird der Datensatz gelscht."
                                //"Nothing to delete!"
#define NOTHINGTODELETE         "Da ist nichts zum Lschen!"
                                //"Abandoning the row will cancel the filter!"
#define ABANDONWILLCANCELFILTER "Der Filter wird aufgehoben, wenn du diesen Datensatz "+;
                                "verwirfst!"
                                //"Abandoning the row will cancel the locate!"
#define ABANDONWILLCANCELLOCATE "Die Suchmaske wird aufgehoben, wenn du diesen Datensatz "+;
                                "verwirfst!"
                                //"Cannot Abandon edits/new row when you weren't editing/adding!"
#define NOTHINGTOABANDON        "Kann nderungen/neuen Datensatz nicht verwerfen, da du weder etwas "+;
                                "gendert, noch hinzugefgt hast!"
                                //"No Match"
#define NOMATCH                 "Kein passender Datensatz!"
                                //"Exit from filter mode!"
#define EXITFROMFILTER          "Filter verlassen!"
                                //"No more matches!"
#define NOMOREMATCHES           "Keine weiteren passenden Datenstze"
                                //"Can't search in memo field!"
#define CANTSEARCHINMEMO        "Ein Memo-Feld kann ich nicht durchsuchen!"
                                //"Can't filter on a memo field!"
#define CANTFILTERINMEMO        "Ein Memo-Feld kann keine Filterbedingung sein!"

// ------------------------------------------------------------
// Misc Titles
                                //"Can't Add a new row!"
#define CANTADDROW              "Kann keinen neuen Datensatz anfgen!"
                                //"Can't Copy row!"
#define CANTCOPYROW             "Kann den Datensatz nicht kopieren!"
                                //"Copy complete"
#define COPYCOMPLETE            "Kopie durchgefhrt."
                                //"Can't Edit row!"
#define CANTEDITROW             "Kann den Datensatz nicht ndern!"
                                //"Can't Save row!"
#define CANTSAVEROW             "Kann den Datensatz nicht speichern!"
                                //"No changes to save!"
#define NOCHANGES               "Es gibt keine nderungen zu speichern!"
                                //"Can't Delete row!"
#define CANTDELETEROW           "Kann den Datensatz nicht lschen!"
                                //"Alert"
#define ALERT                   "Achtung"
                                //"Empty table"
#define EMPTYTABLETEXT          "Die Tabelle ist leer"
                                //"Cancel Filter?"
#define CANCELFILTER            "Filter verwerfen?"
                                //"Cancel Locate?"
#define CANCELLOCATE            "Suchmaske verwerfen?"
                                //"Can't abandon row!"
#define CANTABANDONROW          "Kann Datensatz nicht verwerfen!"
                                //"Can't set a filter!"
#define CANTSETFILTER           "Kann keinen Filter anbringen!"
                                //"Filter"
#define FILTERTEXT              "Filter"
                                //"Can't start a search!"
#define CANTSEARCH              "Kann keine Suche starten!"
                                //"Search"
#define SEARCH                  "Suchmaske"

// -----------------------------------------------------------
// kmRowState -- states:
				                    //"Closed"
#define STATECLOSED             "Geschlossen"
                                //"View" // or "Browse"
#define STATEVIEW               "Ansicht"
                                //"Edit"
#define STATEEDIT               "ndern"
                                //"Append"
#define STATEAPPEND             "Anfgen"
                                //"Filter"
#define STATEFILTER             "Filtern"
                                //"Locate"
#define STATELOCATE             "Suchen"

// -----------------------------------------------------------
// End of header file: custbuttGerman.h
// -----------------------------------------------------------

